/* ---------------------------------------------------------------- *\

sakla - Disk zerinde dosya eklinde disket saklama. Uyarlama 2.00.

	(C) Fedon Kadifeli 1989-1993.

	Derleyici: Microsoft C. Uyarlama 8.00.

	Aklama:

Bu program bir disketi blok blok okuyup diskteki tek bir dosya iine
kopyalamakta veya bu iin tam tersini yapmaktadr.

Bir numaral seenek, programn disketi sektr sektr okuyup, ad
kullancdan alnan, bir disk dosyas iine kopyalamasn salar.
ki numaral seenek bu iin tersini yapar; daha nce, bir numaral
seenek kullanlarak, disk dosyas iine aktarlm olan bir disket
grntsnn sektr sektr okunup formatlanm bir diskete
aktarlmasn salar.  nolu seenek diskteki dosya ile disketi
karlatrr; bu seenek, bir veya iki nolu seenekler kullanlarak
yaplan bir kopyalama ileminden sonra, ilemin doruluunu snamak
iin kullanlabilir.

Not: Bu program kullanlrken dikkat edilmesi gereken bir nokta
disket kapasitesidir. lenen bilgi miktar kilobayt cinsinden
ekranda grntlenir. rnein 1.44 megabaytlk bir disket ile ilem
yapldnda ekrandaki saynn son durumu 1440 olmaldr. Programda
kullanlan kesintinin gerek disket kapasitesini anlamas olas
deildir; MS-DOS ortamnda iken en son yaplan disket ilemindeki
disket kapasitesi kullanlr. Bu yzden, herhangi bir sorun kmamas
iin, program kullanlmadan nce, kullanlacak disket tipinden bir
disket srcye taklp, rnein "DIR A:" veya "CHKDSK A:" eklinde
bir MS-DOS komutu altrlmaldr. Bundan sonra, program
yrtlmesi esnasnda, kullanlan disketlerin kapasitesi deimedii
srece, herhangi bir sorun kmayacaktr. Dikkat edilmesi gereken bir
dier nokta da, kullanlan disketlerin formatl olmas ve bozuk
sektrlerin bulunmamasdr.

\* ---------------------------------------------------------------- */

#include  <stdio.h>
#include  <stdlib.h>
#include  <conio.h>	/* MS-CL */

#define M_OKU   (0x25)	/* mutlak disk okuma kesinti kodu */
#define M_YAZ   (0x26)	/* mutlak disk yazma kesinti kodu */
#define SEKTOR  ((size_t)512) /* sektor boyu                    */
#define IOS     ((size_t)48)  /* bellek tampon boyu (sektor)    */
#define BBS     (1024/SEKTOR) /* 1K'lik bloklar                 */
#define MAKS_DB (66)	/* en uzun dosya ismi boyu        */

typedef unsigned char  BAYT;  /* 8 bit */

BAYT  tam1 [IOS*SEKTOR], tam2 [IOS*SEKTOR];

/* karsilastirma islemi */
int esit (register BAYT * a, register BAYT * b, register size_t u)
{
  while (u--)
    if (*a++ != *b++)
      return 0;	/* uyusmuyor */
  return 1;	/* uyusuyor  */
}  /* esit */

/* mutlak disk girdi/cikti */
size_t mdisk (BAYT kesno, BAYT surno, size_t seksay, size_t sekno,
  BAYT * aktadr)
{
  size_t dondeg;
  __asm {
       push    di	; yazmaclari
       push    si	;  sakla
       push    bp
       mov     ah,kesno	; kesinti numarasi (M_OKU, M_YAZ)
       mov     al,surno	; disket surucu numarasi
       sub     al,'A'	; 'A' -> 0, 'B' -> 1
       mov     cx,seksay	; sektor sayisi
       mov     dx,sekno	; sektor numarasi
       mov     bx,aktadr	; aktarma adresi
       cmp     ah,M_OKU
       jne     else	; eger M_YAZ ise
       int     M_OKU
       jmp     SHORT devam
else:  int     M_YAZ
devam: pushf
       pop     ax	; bayraklari al
       and     ax,1	; hata biti (kesinti donus degeri)
       popf	; bayraklari geri al
       pop     bp	; yazmaclari
       pop     si	;  geri al
       pop     di
       mov     dondeg,ax
  }
  return !dondeg;	/* 0 hata; 1 tamam */
}  /* mdisk */

/* menu seceneklerini sor */
int mensor (void)
{
  int  sec;
  static char * scnklr [] = {
    "\n",
    " 1. Sakla\tDisket --> Disk",
    " 2. Yukle\tDisket <-- Disk",
    " 3. Karsilastir\tDisket <-> Disk" };

  printf("\n\n\t%s\n\t%s\n\t%s\n\nSecenek:",
    scnklr[1], scnklr[2], scnklr[3]);
  if ((sec = _getch()) == '1' || sec == 'S' || sec == 's')
    sec = 1;
  else if (sec == '2' || sec == 'Y' || sec == 'y')
    sec = 2;
  else if (sec == '3' || sec == 'K' || sec == 'k')
    sec = 3;
  else
    sec = 0;
  puts(scnklr[sec]);
  return sec;
}  /* mensor */

/* kullanilacak disket surucusunu sor */
int sursor (void)
{
  int  sur;

  printf("Disket surucusu (A/B): ");
  if ((sur = toupper(_getch())) != 'A' && sur != 'B')
    sur = 0;
  printf(sur ? "%c:\n" : "\n", sur);
  return sur;
}  /* sursor */

/* kullanilacak disk dosyasinin adini sor */
char * dossor (void)
{
  static char  da [MAKS_DB+3] = { MAKS_DB+1 };

  printf("Disk dosya adi: ");
  _cgets(da);
  putchar('\n');
  return da[2] ? da+2 : NULL;
}  /* dossor */

int main (void)
{
  int    secenek, surucu;
  char * da;
  FILE * dg;
  int    b;
  size_t i, d1, d2;

  printf("Disk uzerinde dosya seklinde disket saklama."
    " Uyarlama 2.00.\n(C) Fedon Kadifeli 1989-1993.\n");
  while ((secenek = mensor()) != 0)
    while ((surucu = sursor()) != 0)
      while ((da = dossor()) != NULL) {
        i = 0;
        d1 = 1;
        b = 0;
        /* 1 nolu secenek : Disket --> Disk */
        if (secenek == 1) {
          if ((dg = fopen(da,"rb")) != NULL) {
            fclose(dg);
            printf("'%s' dosyasi zaten var!\n", da);
            continue;
          }
          if ((dg = fopen(da,"wb")) == NULL) {
            printf("'%s' dosyasi acilamiyor!\n", da);
            continue;
          }
          while (mdisk(M_OKU, (BAYT)surucu, IOS, i, tam1) &&
            (d1=fwrite((void *)tam1, SEKTOR, IOS, dg)==IOS) != 0)
              printf("\r%d", (i+=IOS)/BBS);
          printf(d1 ? (i?" adet blok '%s' dosyasina aktarildi.\n"
                        :".  Disket okunamadi!\a\n")
                    : ".  '%s' dosyasinda yazma hatasi!\a\n", da);
        } else  {
        /* 2 veya 3 nolu secenek */
          if ((dg = fopen(da,"rb")) == NULL) {
            printf("'%s' dosyasi acilamiyor!\n", da);
            continue;
          }
          /* 2 nolu secenek : Disket <-- Disk */
          if (secenek == 2) {
            while (fread((void *)tam1, SEKTOR, IOS, dg) == IOS &&
              (d1=mdisk(M_YAZ, (BAYT)surucu, IOS, i, tam1)) != 0)
                printf("\r%d", (i+=IOS)/BBS);
            printf(d1 ? " adet blok diskete aktarildi.\n"
                      : ".  Diskette yazma hatasi!\a\n");
          }  else {
          /* 3 nolu secenek : Disket <-> Disk */
            while ((d1=mdisk(M_OKU, (BAYT)surucu, IOS, i, tam1)) &
              (d2=fread((void *)tam2, SEKTOR, IOS, dg)==IOS) &&
              (b =esit(tam1, tam2, IOS*SEKTOR)) != 0)
                printf("\r%d", (i+=IOS)/BBS);
            printf(
              !b ? ".  Karsilastirma hatasi!\a\n" :
              d1 ? ".  Dosya disketten kisa!\a\n" :
              d2 ? ".  Disket dosyadan kisa!\a\n" :
                   " adet blok uyusuyor.\n");
          }
        }  /* if */
        fclose(dg);
      }  /* while */
  printf("\nIslem tamamlandi\n");
  return 0;
}  /* main */
